#include "dp83848.h"
#include "stm32f4x7_eth.h"
#include "usart.h" 
#include "delay.h"
#include "malloc.h" 


ETH_DMADESCTypeDef *DMARxDscrTab;	//̫DMAݽṹָ
ETH_DMADESCTypeDef *DMATxDscrTab;	//̫DMAݽṹָ 
uint8_t *Rx_Buff; 					//̫ײbuffersָ 
uint8_t *Tx_Buff; 					//̫ײbuffersָ
  
static void ETHERNET_NVICCongfiguration(void);
/*
 *DP83848STM32F4
 *ETH_MDIO -------------------------> PA2
 *ETH_MDC --------------------------> PC1
 *ETH_RMII_REF_CLK------------------> PA1
 *ETH_RMII_CRS_DV ------------------> PA7
 *ETH_RMII_RXD0 --------------------> PC4
 *ETH_RMII_RXD1 --------------------> PC5
 *ETH_RMII_TX_EN -------------------> PB11
 *ETH_RMII_TXD0 --------------------> PB12
 *ETH_RMII_TXD1 --------------------> PB13
*/

u8 DP83848_Init()
{
  u8 rval = 0;
	GPIO_InitTypeDef   GPIO_InitStructure;
	
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA|RCC_AHB1Periph_GPIOB|
	                       RCC_AHB1Periph_GPIOC,ENABLE);//ʹGPIOʱ
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_SYSCFG,ENABLE);//ʹSYSCLKʱ
	
   GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL ;   
  GPIO_Init(GPIOA, &GPIO_InitStructure);
//	RCC_MCO1Config(RCC_MCO1Source_HSE, RCC_MCO1Div_1);
	
	SYSCFG_ETH_MediaInterfaceConfig(SYSCFG_ETH_MediaInterface_RMII);//MACPHY֮ʹRMIIӿ
	//PA1 PA2 PA7
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1|GPIO_Pin_2|GPIO_Pin_7;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
	GPIO_Init(GPIOA,&GPIO_InitStructure);
	
	GPIO_PinAFConfig(GPIOA,GPIO_PinSource1,GPIO_AF_ETH);
	GPIO_PinAFConfig(GPIOA,GPIO_PinSource2,GPIO_AF_ETH);
	GPIO_PinAFConfig(GPIOA,GPIO_PinSource7,GPIO_AF_ETH);
	
	//PB11 PB12 PB13
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11|GPIO_Pin_12|GPIO_Pin_13;
	GPIO_Init(GPIOB,&GPIO_InitStructure);
	GPIO_PinAFConfig(GPIOB,GPIO_PinSource11,GPIO_AF_ETH);
	GPIO_PinAFConfig(GPIOB,GPIO_PinSource12,GPIO_AF_ETH);
	GPIO_PinAFConfig(GPIOB,GPIO_PinSource13,GPIO_AF_ETH);
	//PC1 PC4 PC5
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1|GPIO_Pin_4|GPIO_Pin_5;
	GPIO_Init(GPIOC,&GPIO_InitStructure);
	GPIO_PinAFConfig(GPIOC,GPIO_PinSource1,GPIO_AF_ETH);
	GPIO_PinAFConfig(GPIOC,GPIO_PinSource4,GPIO_AF_ETH);
	GPIO_PinAFConfig(GPIOC,GPIO_PinSource5,GPIO_AF_ETH);
	
	ETHERNET_NVICCongfiguration();
	rval = ETH_MACDMA_Config();
	return !rval;//ETHĹΪ0ʧܣ1ɹҪȡһ
}

void ETHERNET_NVICCongfiguration(void)
{
  NVIC_InitTypeDef  NVIC_InitStructure;
	
	NVIC_InitStructure.NVIC_IRQChannel = ETH_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;//жϼĴ2ȼ
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0x00;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);
}

u8 ETH_MACDMA_Config()
{
  u8  rval;
	ETH_InitTypeDef ETH_InitStructure;
	//ʹ̫ʱ
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_ETH_MAC|RCC_AHB1Periph_ETH_MAC_Tx|RCC_AHB1Periph_ETH_MAC_Rx,ENABLE);
	
		ETH_DeInit();  								//AHB̫
	ETH_SoftwareReset();  						//
	while (ETH_GetSoftwareResetStatus() == SET);//ȴ 
	ETH_StructInit(&ETH_InitStructure); 	 	//ʼΪĬֵ  

	///MAC 
	ETH_InitStructure.ETH_AutoNegotiation = ETH_AutoNegotiation_Enable;   			//Ӧ
	ETH_InitStructure.ETH_LoopbackMode = ETH_LoopbackMode_Disable;					//رշ
	ETH_InitStructure.ETH_RetryTransmission = ETH_RetryTransmission_Disable; 		//رش
	ETH_InitStructure.ETH_AutomaticPadCRCStrip = ETH_AutomaticPadCRCStrip_Disable; 	//رԶȥPDA/CRC 
	ETH_InitStructure.ETH_ReceiveAll = ETH_ReceiveAll_Disable;						//رսе֡
	ETH_InitStructure.ETH_BroadcastFramesReception = ETH_BroadcastFramesReception_Enable;//й㲥֡
	ETH_InitStructure.ETH_PromiscuousMode = ETH_PromiscuousMode_Disable;			//رջģʽĵַ  
	ETH_InitStructure.ETH_MulticastFramesFilter = ETH_MulticastFramesFilter_Perfect;//鲥ַʹַ   
	ETH_InitStructure.ETH_UnicastFramesFilter = ETH_UnicastFramesFilter_Perfect;	//Եַʹַ 
#ifdef CHECKSUM_BY_HARDWARE
	ETH_InitStructure.ETH_ChecksumOffload = ETH_ChecksumOffload_Enable; 			//ipv4TCP/UDP/ICMP֡Уж   
#endif
	//ʹ֡УжعܵʱһҪʹܴ洢תģʽ,洢תģʽҪ֤֡洢FIFO,
	//MACܲ/ʶ֡Уֵ,УȷʱDMAͿԴ֡,Ͷ֡
	ETH_InitStructure.ETH_DropTCPIPChecksumErrorFrame = ETH_DropTCPIPChecksumErrorFrame_Enable; //TCP/IP֡
	ETH_InitStructure.ETH_ReceiveStoreForward = ETH_ReceiveStoreForward_Enable;     //ݵĴ洢תģʽ    
	ETH_InitStructure.ETH_TransmitStoreForward = ETH_TransmitStoreForward_Enable;   //ݵĴ洢תģʽ  

	ETH_InitStructure.ETH_ForwardErrorFrames = ETH_ForwardErrorFrames_Disable;     	//ֹת֡  
	ETH_InitStructure.ETH_ForwardUndersizedGoodFrames = ETH_ForwardUndersizedGoodFrames_Disable;	//תСĺ֡ 
	ETH_InitStructure.ETH_SecondFrameOperate = ETH_SecondFrameOperate_Enable;  		//򿪴ڶ֡
	ETH_InitStructure.ETH_AddressAlignedBeats = ETH_AddressAlignedBeats_Enable;  	//DMAĵַ빦
	ETH_InitStructure.ETH_FixedBurst = ETH_FixedBurst_Enable;            			//̶ͻ    
	ETH_InitStructure.ETH_RxDMABurstLength = ETH_RxDMABurstLength_32Beat;     		//DMA͵ͻΪ32   
	ETH_InitStructure.ETH_TxDMABurstLength = ETH_TxDMABurstLength_32Beat;			//DMAյͻΪ32
	ETH_InitStructure.ETH_DMAArbitration = ETH_DMAArbitration_RoundRobin_RxTx_2_1;
	rval=ETH_Init(&ETH_InitStructure,DP83848_PHY_ADDRESS);		//ETH
	if(rval==ETH_SUCCESS)//óɹ
	{
		ETH_DMAITConfig(ETH_DMA_IT_NIS|ETH_DMA_IT_R,ENABLE);  	//ʹ̫ж	
	}
	return rval;
	
}


extern void lwip_pkt_handle(void);		//lwip_comm.c涨
//̫жϷ
void ETH_IRQHandler(void)
{
	while(ETH_GetRxPktSize(DMARxDescToGet)!=0) 	//Ƿյݰ
	{ 
		lwip_pkt_handle();		
	}
	ETH_DMAClearITPendingBit(ETH_DMA_IT_R);
	ETH_DMAClearITPendingBit(ETH_DMA_IT_NIS);
}  

u8 DP83848_Get_Speed(void)
{
  u8 speed;
	speed = ((ETH_ReadPHYRegister(0x00,16)&0x06)>>1);
	return speed;
}


//һݰ
//ֵ:ݰ֡ṹ
FrameTypeDef ETH_Rx_Packet(void)
{ 
	u32 framelength=0;
	FrameTypeDef frame={0,0};   
	//鵱ǰ,ǷETHERNET DMA(õʱ)/CPU(λʱ)
	if((DMARxDescToGet->Status&ETH_DMARxDesc_OWN)!=(u32)RESET)
	{	
		frame.length=ETH_ERROR; 
		if ((ETH->DMASR&ETH_DMASR_RBUS)!=(u32)RESET)  
		{ 
			ETH->DMASR = ETH_DMASR_RBUS;//ETH DMARBUSλ 
			ETH->DMARPDR=0;//ָDMA
		}
		return frame;//,OWNλ
	}  
	if(((DMARxDescToGet->Status&ETH_DMARxDesc_ES)==(u32)RESET)&& 
	((DMARxDescToGet->Status & ETH_DMARxDesc_LS)!=(u32)RESET)&&  
	((DMARxDescToGet->Status & ETH_DMARxDesc_FS)!=(u32)RESET))  
	{       
		framelength=((DMARxDescToGet->Status&ETH_DMARxDesc_FL)>>ETH_DMARxDesc_FrameLengthShift)-4;//õհ֡(4ֽCRC)
 		frame.buffer = DMARxDescToGet->Buffer1Addr;//õڵλ
	}else framelength=ETH_ERROR;//  
	frame.length=framelength; 
	frame.descriptor=DMARxDescToGet;  
	//ETH DMAȫRxΪһRx
	//ΪһbufferȡһDMA Rx
	DMARxDescToGet=(ETH_DMADESCTypeDef*)(DMARxDescToGet->Buffer2NextDescAddr);   
	return frame;  
}
//һݰ
//FrameLength:ݰ
//ֵ:ETH_ERROR,ʧ(0)
//		ETH_SUCCESS,ͳɹ(1)
u8 ETH_Tx_Packet(u16 FrameLength)
{   
	//鵱ǰ,ǷETHERNET DMA(õʱ)/CPU(λʱ)
	if((DMATxDescToSet->Status&ETH_DMATxDesc_OWN)!=(u32)RESET)return ETH_ERROR;//,OWNλ 
 	DMATxDescToSet->ControlBufferSize=(FrameLength&ETH_DMATxDesc_TBS1);//֡,bits[12:0]
	DMATxDescToSet->Status|=ETH_DMATxDesc_LS|ETH_DMATxDesc_FS;//һ͵һλλ(1һ֡)
  	DMATxDescToSet->Status|=ETH_DMATxDesc_OWN;//TxOWNλ,bufferعETH DMA
	if((ETH->DMASR&ETH_DMASR_TBUS)!=(u32)RESET)//Tx Bufferλ(TBUS)õʱ,.ָ
	{ 
		ETH->DMASR=ETH_DMASR_TBUS;//ETH DMA TBUSλ 
		ETH->DMATPDR=0;//ָDMA
	} 
	//ETH DMAȫTxΪһTx
	//ΪһbufferһDMA Tx 
	DMATxDescToSet=(ETH_DMADESCTypeDef*)(DMATxDescToSet->Buffer2NextDescAddr);    
	return ETH_SUCCESS;   
}
//õǰTx bufferַ
//ֵ:Tx bufferַ
u32 ETH_GetCurrentTxBuffer(void)
{  
  return DMATxDescToSet->Buffer1Addr;//Tx bufferַ  
}

//ΪETHײڴ
//ֵ:0,
//    ,ʧ
u8 ETH_Mem_Malloc(void)
{ 
	DMARxDscrTab=mymalloc(SRAMIN,ETH_RXBUFNB*sizeof(ETH_DMADESCTypeDef));//ڴ
	DMATxDscrTab=mymalloc(SRAMIN,ETH_TXBUFNB*sizeof(ETH_DMADESCTypeDef));//ڴ  
	Rx_Buff=mymalloc(SRAMIN,ETH_RX_BUF_SIZE*ETH_RXBUFNB);	//ڴ
	Tx_Buff=mymalloc(SRAMIN,ETH_TX_BUF_SIZE*ETH_TXBUFNB);	//ڴ
	if(!DMARxDscrTab||!DMATxDscrTab||!Rx_Buff||!Tx_Buff)
	{
		ETH_Mem_Free();
		return 1;	//ʧ
	}	
	return 0;		//ɹ
}

//ͷETH ײڴ
void ETH_Mem_Free(void)
{ 
	myfree(SRAMIN,DMARxDscrTab);//ͷڴ
	myfree(SRAMIN,DMATxDscrTab);//ͷڴ
	myfree(SRAMIN,Rx_Buff);		//ͷڴ
	myfree(SRAMIN,Tx_Buff);		//ͷڴ  
}

















